/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MATHML)

#include "JSMathMLElement.h"

#include "ActiveDOMObject.h"
#include "CustomElementReactionQueue.h"
#include "DOMIsoSubspaces.h"
#include "EventNames.h"
#include "JSCSSStyleDeclaration.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMStringMap.h"
#include "JSDOMWrapperCache.h"
#include "JSEventListener.h"
#include "RuntimeEnabledFeatures.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>

#if ENABLE(CSS_TYPED_OM)
#include "JSStylePropertyMap.h"
#endif


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsMathMLElementPrototypeFunction_focus);
static JSC_DECLARE_HOST_FUNCTION(jsMathMLElementPrototypeFunction_blur);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElementConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_style);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_style);
#if ENABLE(CSS_TYPED_OM)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_attributeStyleMap);
#endif
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_oncopy);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_oncopy);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_oncut);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_oncut);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpaste);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpaste);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onbeforecopy);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onbeforecopy);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onbeforecut);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onbeforecut);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onbeforeinput);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onbeforeinput);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onbeforepaste);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onbeforepaste);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onabort);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onabort);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onblur);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onblur);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_oncanplay);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_oncanplay);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_oncanplaythrough);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_oncanplaythrough);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onchange);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onchange);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onclick);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onclick);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_oncontextmenu);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_oncontextmenu);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_oncuechange);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_oncuechange);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondblclick);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondblclick);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondrag);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondrag);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondragend);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondragend);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondragenter);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondragenter);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondragleave);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondragleave);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondragover);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondragover);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondragstart);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondragstart);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondrop);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondrop);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ondurationchange);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ondurationchange);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onemptied);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onemptied);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onended);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onended);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onerror);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onerror);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onfocus);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onfocus);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_oninput);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_oninput);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_oninvalid);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_oninvalid);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onkeydown);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onkeydown);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onkeypress);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onkeypress);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onkeyup);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onkeyup);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onload);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onload);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onloadeddata);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onloadeddata);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onloadedmetadata);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onloadedmetadata);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onloadstart);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onloadstart);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onmousedown);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onmousedown);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onmouseenter);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onmouseenter);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onmouseleave);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onmouseleave);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onmousemove);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onmousemove);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onmouseout);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onmouseout);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onmouseover);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onmouseover);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onmouseup);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onmouseup);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpause);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpause);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onplay);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onplay);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onplaying);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onplaying);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onprogress);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onprogress);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onratechange);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onratechange);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onreset);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onreset);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onresize);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onresize);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onscroll);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onscroll);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onseeked);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onseeked);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onseeking);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onseeking);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onselect);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onselect);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onslotchange);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onslotchange);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onstalled);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onstalled);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onsubmit);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onsubmit);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onsuspend);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onsuspend);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontimeupdate);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontimeupdate);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontoggle);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontoggle);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onvolumechange);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onvolumechange);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwaiting);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwaiting);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwebkitanimationend);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwebkitanimationend);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwebkitanimationiteration);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwebkitanimationiteration);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwebkitanimationstart);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwebkitanimationstart);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwebkittransitionend);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwebkittransitionend);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwheel);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwheel);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onmousewheel);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onmousewheel);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onsearch);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onsearch);
#if ENABLE(TOUCH_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontouchcancel);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontouchcancel);
#endif
#if ENABLE(TOUCH_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontouchend);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontouchend);
#endif
#if ENABLE(TOUCH_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontouchmove);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontouchmove);
#endif
#if ENABLE(TOUCH_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontouchstart);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontouchstart);
#endif
#if ENABLE(TOUCH_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontouchforcechange);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontouchforcechange);
#endif
#if ENABLE(MOUSE_FORCE_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwebkitmouseforcechanged);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwebkitmouseforcechanged);
#endif
#if ENABLE(MOUSE_FORCE_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwebkitmouseforcedown);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwebkitmouseforcedown);
#endif
#if ENABLE(MOUSE_FORCE_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwebkitmouseforcewillbegin);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwebkitmouseforcewillbegin);
#endif
#if ENABLE(MOUSE_FORCE_EVENTS)
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onwebkitmouseforceup);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onwebkitmouseforceup);
#endif
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onanimationstart);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onanimationstart);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onanimationiteration);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onanimationiteration);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onanimationend);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onanimationend);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onanimationcancel);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onanimationcancel);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontransitionrun);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontransitionrun);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontransitionstart);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontransitionstart);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontransitionend);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontransitionend);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ontransitioncancel);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ontransitioncancel);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_ongotpointercapture);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_ongotpointercapture);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onlostpointercapture);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onlostpointercapture);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpointerdown);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpointerdown);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpointermove);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpointermove);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpointerup);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpointerup);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpointercancel);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpointercancel);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpointerover);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpointerover);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpointerout);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpointerout);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpointerenter);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpointerenter);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onpointerleave);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onpointerleave);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onselectstart);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onselectstart);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_onselectionchange);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_onselectionchange);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_dataset);
static JSC_DECLARE_CUSTOM_GETTER(jsMathMLElement_tabIndex);
static JSC_DECLARE_CUSTOM_SETTER(setJSMathMLElement_tabIndex);

class JSMathMLElementPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSMathMLElementPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMathMLElementPrototype* ptr = new (NotNull, JSC::allocateCell<JSMathMLElementPrototype>(vm.heap)) JSMathMLElementPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSMathMLElementPrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMathMLElementPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSMathMLElementPrototype, JSMathMLElementPrototype::Base);

using JSMathMLElementDOMConstructor = JSDOMConstructorNotConstructable<JSMathMLElement>;

template<> JSValue JSMathMLElementDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSElement::getConstructor(vm, &globalObject);
}

template<> void JSMathMLElementDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSMathMLElement::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, "MathMLElement"_s), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSMathMLElementDOMConstructor::s_info = { "MathMLElement", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMathMLElementDOMConstructor) };

/* Hash table for prototype */

static const HashTableValue JSMathMLElementPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElementConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "style", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_style), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_style) } },
#if ENABLE(CSS_TYPED_OM)
    { "attributeStyleMap", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_attributeStyleMap), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
    { "oncopy", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_oncopy), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_oncopy) } },
    { "oncut", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_oncut), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_oncut) } },
    { "onpaste", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpaste), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpaste) } },
    { "onbeforecopy", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onbeforecopy), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onbeforecopy) } },
    { "onbeforecut", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onbeforecut), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onbeforecut) } },
    { "onbeforeinput", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onbeforeinput), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onbeforeinput) } },
    { "onbeforepaste", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onbeforepaste), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onbeforepaste) } },
    { "onabort", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onabort), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onabort) } },
    { "onblur", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onblur), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onblur) } },
    { "oncanplay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_oncanplay), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_oncanplay) } },
    { "oncanplaythrough", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_oncanplaythrough), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_oncanplaythrough) } },
    { "onchange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onchange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onchange) } },
    { "onclick", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onclick), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onclick) } },
    { "oncontextmenu", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_oncontextmenu), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_oncontextmenu) } },
    { "oncuechange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_oncuechange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_oncuechange) } },
    { "ondblclick", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondblclick), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondblclick) } },
    { "ondrag", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondrag), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondrag) } },
    { "ondragend", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondragend), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondragend) } },
    { "ondragenter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondragenter), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondragenter) } },
    { "ondragleave", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondragleave), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondragleave) } },
    { "ondragover", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondragover), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondragover) } },
    { "ondragstart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondragstart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondragstart) } },
    { "ondrop", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondrop), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondrop) } },
    { "ondurationchange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ondurationchange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ondurationchange) } },
    { "onemptied", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onemptied), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onemptied) } },
    { "onended", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onended), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onended) } },
    { "onerror", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onerror), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onerror) } },
    { "onfocus", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onfocus), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onfocus) } },
    { "oninput", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_oninput), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_oninput) } },
    { "oninvalid", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_oninvalid), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_oninvalid) } },
    { "onkeydown", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onkeydown), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onkeydown) } },
    { "onkeypress", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onkeypress), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onkeypress) } },
    { "onkeyup", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onkeyup), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onkeyup) } },
    { "onload", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onload), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onload) } },
    { "onloadeddata", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onloadeddata), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onloadeddata) } },
    { "onloadedmetadata", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onloadedmetadata), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onloadedmetadata) } },
    { "onloadstart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onloadstart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onloadstart) } },
    { "onmousedown", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onmousedown), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onmousedown) } },
    { "onmouseenter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onmouseenter), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onmouseenter) } },
    { "onmouseleave", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onmouseleave), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onmouseleave) } },
    { "onmousemove", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onmousemove), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onmousemove) } },
    { "onmouseout", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onmouseout), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onmouseout) } },
    { "onmouseover", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onmouseover), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onmouseover) } },
    { "onmouseup", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onmouseup), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onmouseup) } },
    { "onpause", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpause), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpause) } },
    { "onplay", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onplay), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onplay) } },
    { "onplaying", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onplaying), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onplaying) } },
    { "onprogress", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onprogress), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onprogress) } },
    { "onratechange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onratechange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onratechange) } },
    { "onreset", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onreset), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onreset) } },
    { "onresize", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onresize), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onresize) } },
    { "onscroll", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onscroll), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onscroll) } },
    { "onseeked", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onseeked), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onseeked) } },
    { "onseeking", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onseeking), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onseeking) } },
    { "onselect", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onselect), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onselect) } },
    { "onslotchange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onslotchange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onslotchange) } },
    { "onstalled", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onstalled), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onstalled) } },
    { "onsubmit", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onsubmit), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onsubmit) } },
    { "onsuspend", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onsuspend), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onsuspend) } },
    { "ontimeupdate", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontimeupdate), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontimeupdate) } },
    { "ontoggle", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontoggle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontoggle) } },
    { "onvolumechange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onvolumechange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onvolumechange) } },
    { "onwaiting", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwaiting), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwaiting) } },
    { "onwebkitanimationend", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwebkitanimationend), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwebkitanimationend) } },
    { "onwebkitanimationiteration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwebkitanimationiteration), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwebkitanimationiteration) } },
    { "onwebkitanimationstart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwebkitanimationstart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwebkitanimationstart) } },
    { "onwebkittransitionend", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwebkittransitionend), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwebkittransitionend) } },
    { "onwheel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwheel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwheel) } },
    { "onmousewheel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onmousewheel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onmousewheel) } },
    { "onsearch", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onsearch), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onsearch) } },
#if ENABLE(TOUCH_EVENTS)
    { "ontouchcancel", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontouchcancel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontouchcancel) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(TOUCH_EVENTS)
    { "ontouchend", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontouchend), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontouchend) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(TOUCH_EVENTS)
    { "ontouchmove", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontouchmove), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontouchmove) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(TOUCH_EVENTS)
    { "ontouchstart", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontouchstart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontouchstart) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(TOUCH_EVENTS)
    { "ontouchforcechange", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontouchforcechange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontouchforcechange) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(MOUSE_FORCE_EVENTS)
    { "onwebkitmouseforcechanged", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwebkitmouseforcechanged), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwebkitmouseforcechanged) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(MOUSE_FORCE_EVENTS)
    { "onwebkitmouseforcedown", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwebkitmouseforcedown), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwebkitmouseforcedown) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(MOUSE_FORCE_EVENTS)
    { "onwebkitmouseforcewillbegin", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwebkitmouseforcewillbegin), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwebkitmouseforcewillbegin) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
#if ENABLE(MOUSE_FORCE_EVENTS)
    { "onwebkitmouseforceup", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onwebkitmouseforceup), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onwebkitmouseforceup) } },
#else
    { 0, 0, NoIntrinsic, { 0, 0 } },
#endif
    { "onanimationstart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onanimationstart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onanimationstart) } },
    { "onanimationiteration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onanimationiteration), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onanimationiteration) } },
    { "onanimationend", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onanimationend), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onanimationend) } },
    { "onanimationcancel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onanimationcancel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onanimationcancel) } },
    { "ontransitionrun", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontransitionrun), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontransitionrun) } },
    { "ontransitionstart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontransitionstart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontransitionstart) } },
    { "ontransitionend", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontransitionend), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontransitionend) } },
    { "ontransitioncancel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ontransitioncancel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ontransitioncancel) } },
    { "ongotpointercapture", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_ongotpointercapture), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_ongotpointercapture) } },
    { "onlostpointercapture", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onlostpointercapture), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onlostpointercapture) } },
    { "onpointerdown", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpointerdown), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpointerdown) } },
    { "onpointermove", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpointermove), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpointermove) } },
    { "onpointerup", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpointerup), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpointerup) } },
    { "onpointercancel", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpointercancel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpointercancel) } },
    { "onpointerover", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpointerover), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpointerover) } },
    { "onpointerout", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpointerout), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpointerout) } },
    { "onpointerenter", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpointerenter), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpointerenter) } },
    { "onpointerleave", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onpointerleave), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onpointerleave) } },
    { "onselectstart", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onselectstart), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onselectstart) } },
    { "onselectionchange", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_onselectionchange), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_onselectionchange) } },
    { "dataset", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_dataset), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "tabIndex", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMathMLElement_tabIndex), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMathMLElement_tabIndex) } },
    { "focus", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMathMLElementPrototypeFunction_focus), (intptr_t) (0) } },
    { "blur", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsMathMLElementPrototypeFunction_blur), (intptr_t) (0) } },
};

const ClassInfo JSMathMLElementPrototype::s_info = { "MathMLElement", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMathMLElementPrototype) };

void JSMathMLElementPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMathMLElement::info(), JSMathMLElementPrototypeTableValues, *this);
    bool hasDisabledRuntimeProperties = false;
#if ENABLE(CSS_TYPED_OM)
    if (!RuntimeEnabledFeatures::sharedFeatures().cssTypedOMEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("attributeStyleMap"), strlen("attributeStyleMap"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#endif
#if ENABLE(TOUCH_EVENTS)
    if (!RuntimeEnabledFeatures::sharedFeatures().touchEventsEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("ontouchcancel"), strlen("ontouchcancel"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#endif
#if ENABLE(TOUCH_EVENTS)
    if (!RuntimeEnabledFeatures::sharedFeatures().touchEventsEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("ontouchend"), strlen("ontouchend"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#endif
#if ENABLE(TOUCH_EVENTS)
    if (!RuntimeEnabledFeatures::sharedFeatures().touchEventsEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("ontouchmove"), strlen("ontouchmove"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#endif
#if ENABLE(TOUCH_EVENTS)
    if (!RuntimeEnabledFeatures::sharedFeatures().touchEventsEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("ontouchstart"), strlen("ontouchstart"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#endif
#if ENABLE(TOUCH_EVENTS)
    if (!RuntimeEnabledFeatures::sharedFeatures().touchEventsEnabled()) {
        hasDisabledRuntimeProperties = true;
        auto propertyName = Identifier::fromString(vm, reinterpret_cast<const LChar*>("ontouchforcechange"), strlen("ontouchforcechange"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        DeletePropertySlot slot;
        JSObject::deleteProperty(this, globalObject(), propertyName, slot);
    }
#endif
    if (hasDisabledRuntimeProperties && structure()->isDictionary())
        flattenDictionaryObject(vm);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSMathMLElement::s_info = { "MathMLElement", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSMathMLElement) };

JSMathMLElement::JSMathMLElement(Structure* structure, JSDOMGlobalObject& globalObject, Ref<MathMLElement>&& impl)
    : JSElement(structure, globalObject, WTFMove(impl))
{
}

void JSMathMLElement::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, MathMLElement>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSMathMLElement::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSMathMLElementPrototype::create(vm, &globalObject, JSMathMLElementPrototype::createStructure(vm, &globalObject, JSElement::prototype(vm, globalObject)));
}

JSObject* JSMathMLElement::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSMathMLElement>(vm, globalObject);
}

JSValue JSMathMLElement::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSMathMLElementDOMConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSMathMLElement* IDLAttribute<JSMathMLElement>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSMathMLElement*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

template<> inline JSMathMLElement* IDLOperation<JSMathMLElement>::cast(JSGlobalObject& lexicalGlobalObject, CallFrame& callFrame)
{
    return jsDynamicCast<JSMathMLElement*>(JSC::getVM(&lexicalGlobalObject), callFrame.thisValue());
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElementConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSMathMLElementPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSMathMLElement::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsMathMLElement_styleGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<CSSStyleDeclaration>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.cssomStyle())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_style, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_styleGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "style");
}

static inline bool setJSMathMLElement_styleSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto id = Identifier::fromString(vm, reinterpret_cast<const LChar*>("style"), strlen("style"));
    auto valueToForwardTo = thisObject.get(&lexicalGlobalObject, id);
    RETURN_IF_EXCEPTION(throwScope, false);
    if (UNLIKELY(!valueToForwardTo.isObject())) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return false;
    }
    auto forwardId = Identifier::fromString(vm, reinterpret_cast<const LChar*>("cssText"), strlen("cssText"));
    PutPropertySlot slot(valueToForwardTo, false);
    asObject(valueToForwardTo)->methodTable(vm)->put(asObject(valueToForwardTo), &lexicalGlobalObject, forwardId, value, slot);
    RETURN_IF_EXCEPTION(throwScope, false);
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_style, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_styleSetter>(*lexicalGlobalObject, thisValue, encodedValue, "style");
}

#if ENABLE(CSS_TYPED_OM)
static inline JSValue jsMathMLElement_attributeStyleMapGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    if (JSValue cachedValue = thisObject.m_attributeStyleMap.get())
        return cachedValue;
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<StylePropertyMap>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.ensureAttributeStyleMap());
    RETURN_IF_EXCEPTION(throwScope, { });
    thisObject.m_attributeStyleMap.set(JSC::getVM(&lexicalGlobalObject), &thisObject, result);
    return result;
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_attributeStyleMap, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_attributeStyleMapGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "attributeStyleMap");
}

#endif

static inline JSValue jsMathMLElement_oncopyGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().copyEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_oncopy, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_oncopyGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "oncopy");
}

static inline bool setJSMathMLElement_oncopySetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().copyEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_oncopy, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_oncopySetter>(*lexicalGlobalObject, thisValue, encodedValue, "oncopy");
}

static inline JSValue jsMathMLElement_oncutGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().cutEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_oncut, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_oncutGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "oncut");
}

static inline bool setJSMathMLElement_oncutSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().cutEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_oncut, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_oncutSetter>(*lexicalGlobalObject, thisValue, encodedValue, "oncut");
}

static inline JSValue jsMathMLElement_onpasteGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pasteEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpaste, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpasteGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpaste");
}

static inline bool setJSMathMLElement_onpasteSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pasteEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpaste, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpasteSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpaste");
}

static inline JSValue jsMathMLElement_onbeforecopyGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().beforecopyEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onbeforecopy, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onbeforecopyGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onbeforecopy");
}

static inline bool setJSMathMLElement_onbeforecopySetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().beforecopyEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onbeforecopy, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onbeforecopySetter>(*lexicalGlobalObject, thisValue, encodedValue, "onbeforecopy");
}

static inline JSValue jsMathMLElement_onbeforecutGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().beforecutEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onbeforecut, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onbeforecutGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onbeforecut");
}

static inline bool setJSMathMLElement_onbeforecutSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().beforecutEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onbeforecut, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onbeforecutSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onbeforecut");
}

static inline JSValue jsMathMLElement_onbeforeinputGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().beforeinputEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onbeforeinput, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onbeforeinputGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onbeforeinput");
}

static inline bool setJSMathMLElement_onbeforeinputSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().beforeinputEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onbeforeinput, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onbeforeinputSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onbeforeinput");
}

static inline JSValue jsMathMLElement_onbeforepasteGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().beforepasteEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onbeforepaste, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onbeforepasteGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onbeforepaste");
}

static inline bool setJSMathMLElement_onbeforepasteSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().beforepasteEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onbeforepaste, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onbeforepasteSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onbeforepaste");
}

static inline JSValue jsMathMLElement_onabortGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().abortEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onabort, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onabortGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onabort");
}

static inline bool setJSMathMLElement_onabortSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().abortEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onabort, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onabortSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onabort");
}

static inline JSValue jsMathMLElement_onblurGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().blurEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onblur, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onblurGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onblur");
}

static inline bool setJSMathMLElement_onblurSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().blurEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onblur, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onblurSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onblur");
}

static inline JSValue jsMathMLElement_oncanplayGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().canplayEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_oncanplay, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_oncanplayGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "oncanplay");
}

static inline bool setJSMathMLElement_oncanplaySetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().canplayEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_oncanplay, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_oncanplaySetter>(*lexicalGlobalObject, thisValue, encodedValue, "oncanplay");
}

static inline JSValue jsMathMLElement_oncanplaythroughGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().canplaythroughEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_oncanplaythrough, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_oncanplaythroughGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "oncanplaythrough");
}

static inline bool setJSMathMLElement_oncanplaythroughSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().canplaythroughEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_oncanplaythrough, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_oncanplaythroughSetter>(*lexicalGlobalObject, thisValue, encodedValue, "oncanplaythrough");
}

static inline JSValue jsMathMLElement_onchangeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().changeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onchange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onchangeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onchange");
}

static inline bool setJSMathMLElement_onchangeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().changeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onchange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onchangeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onchange");
}

static inline JSValue jsMathMLElement_onclickGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().clickEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onclick, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onclickGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onclick");
}

static inline bool setJSMathMLElement_onclickSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().clickEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onclick, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onclickSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onclick");
}

static inline JSValue jsMathMLElement_oncontextmenuGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().contextmenuEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_oncontextmenu, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_oncontextmenuGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "oncontextmenu");
}

static inline bool setJSMathMLElement_oncontextmenuSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().contextmenuEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_oncontextmenu, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_oncontextmenuSetter>(*lexicalGlobalObject, thisValue, encodedValue, "oncontextmenu");
}

static inline JSValue jsMathMLElement_oncuechangeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().cuechangeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_oncuechange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_oncuechangeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "oncuechange");
}

static inline bool setJSMathMLElement_oncuechangeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().cuechangeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_oncuechange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_oncuechangeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "oncuechange");
}

static inline JSValue jsMathMLElement_ondblclickGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().dblclickEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondblclick, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondblclickGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondblclick");
}

static inline bool setJSMathMLElement_ondblclickSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().dblclickEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondblclick, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondblclickSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondblclick");
}

static inline JSValue jsMathMLElement_ondragGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().dragEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondrag, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondragGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondrag");
}

static inline bool setJSMathMLElement_ondragSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().dragEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondrag, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondragSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondrag");
}

static inline JSValue jsMathMLElement_ondragendGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().dragendEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondragend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondragendGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondragend");
}

static inline bool setJSMathMLElement_ondragendSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().dragendEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondragend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondragendSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondragend");
}

static inline JSValue jsMathMLElement_ondragenterGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().dragenterEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondragenter, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondragenterGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondragenter");
}

static inline bool setJSMathMLElement_ondragenterSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().dragenterEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondragenter, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondragenterSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondragenter");
}

static inline JSValue jsMathMLElement_ondragleaveGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().dragleaveEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondragleave, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondragleaveGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondragleave");
}

static inline bool setJSMathMLElement_ondragleaveSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().dragleaveEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondragleave, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondragleaveSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondragleave");
}

static inline JSValue jsMathMLElement_ondragoverGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().dragoverEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondragover, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondragoverGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondragover");
}

static inline bool setJSMathMLElement_ondragoverSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().dragoverEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondragover, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondragoverSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondragover");
}

static inline JSValue jsMathMLElement_ondragstartGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().dragstartEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondragstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondragstartGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondragstart");
}

static inline bool setJSMathMLElement_ondragstartSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().dragstartEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondragstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondragstartSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondragstart");
}

static inline JSValue jsMathMLElement_ondropGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().dropEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondrop, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondropGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondrop");
}

static inline bool setJSMathMLElement_ondropSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().dropEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondrop, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondropSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondrop");
}

static inline JSValue jsMathMLElement_ondurationchangeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().durationchangeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ondurationchange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ondurationchangeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ondurationchange");
}

static inline bool setJSMathMLElement_ondurationchangeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().durationchangeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ondurationchange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ondurationchangeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ondurationchange");
}

static inline JSValue jsMathMLElement_onemptiedGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().emptiedEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onemptied, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onemptiedGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onemptied");
}

static inline bool setJSMathMLElement_onemptiedSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().emptiedEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onemptied, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onemptiedSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onemptied");
}

static inline JSValue jsMathMLElement_onendedGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().endedEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onended, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onendedGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onended");
}

static inline bool setJSMathMLElement_onendedSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().endedEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onended, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onendedSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onended");
}

static inline JSValue jsMathMLElement_onerrorGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().errorEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onerror, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onerrorGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onerror");
}

static inline bool setJSMathMLElement_onerrorSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().errorEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onerror, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onerrorSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onerror");
}

static inline JSValue jsMathMLElement_onfocusGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().focusEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onfocus, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onfocusGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onfocus");
}

static inline bool setJSMathMLElement_onfocusSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().focusEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onfocus, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onfocusSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onfocus");
}

static inline JSValue jsMathMLElement_oninputGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().inputEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_oninput, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_oninputGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "oninput");
}

static inline bool setJSMathMLElement_oninputSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().inputEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_oninput, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_oninputSetter>(*lexicalGlobalObject, thisValue, encodedValue, "oninput");
}

static inline JSValue jsMathMLElement_oninvalidGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().invalidEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_oninvalid, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_oninvalidGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "oninvalid");
}

static inline bool setJSMathMLElement_oninvalidSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().invalidEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_oninvalid, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_oninvalidSetter>(*lexicalGlobalObject, thisValue, encodedValue, "oninvalid");
}

static inline JSValue jsMathMLElement_onkeydownGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().keydownEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onkeydown, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onkeydownGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onkeydown");
}

static inline bool setJSMathMLElement_onkeydownSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().keydownEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onkeydown, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onkeydownSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onkeydown");
}

static inline JSValue jsMathMLElement_onkeypressGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().keypressEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onkeypress, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onkeypressGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onkeypress");
}

static inline bool setJSMathMLElement_onkeypressSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().keypressEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onkeypress, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onkeypressSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onkeypress");
}

static inline JSValue jsMathMLElement_onkeyupGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().keyupEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onkeyup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onkeyupGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onkeyup");
}

static inline bool setJSMathMLElement_onkeyupSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().keyupEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onkeyup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onkeyupSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onkeyup");
}

static inline JSValue jsMathMLElement_onloadGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().loadEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onload, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onloadGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onload");
}

static inline bool setJSMathMLElement_onloadSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().loadEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onload, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onloadSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onload");
}

static inline JSValue jsMathMLElement_onloadeddataGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().loadeddataEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onloadeddata, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onloadeddataGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onloadeddata");
}

static inline bool setJSMathMLElement_onloadeddataSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().loadeddataEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onloadeddata, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onloadeddataSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onloadeddata");
}

static inline JSValue jsMathMLElement_onloadedmetadataGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().loadedmetadataEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onloadedmetadata, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onloadedmetadataGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onloadedmetadata");
}

static inline bool setJSMathMLElement_onloadedmetadataSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().loadedmetadataEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onloadedmetadata, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onloadedmetadataSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onloadedmetadata");
}

static inline JSValue jsMathMLElement_onloadstartGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().loadstartEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onloadstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onloadstartGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onloadstart");
}

static inline bool setJSMathMLElement_onloadstartSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().loadstartEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onloadstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onloadstartSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onloadstart");
}

static inline JSValue jsMathMLElement_onmousedownGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().mousedownEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onmousedown, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onmousedownGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onmousedown");
}

static inline bool setJSMathMLElement_onmousedownSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().mousedownEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onmousedown, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onmousedownSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onmousedown");
}

static inline JSValue jsMathMLElement_onmouseenterGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().mouseenterEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onmouseenter, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onmouseenterGetter, CastedThisErrorBehavior::ReturnEarly>(*lexicalGlobalObject, thisValue, "onmouseenter");
}

static inline bool setJSMathMLElement_onmouseenterSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().mouseenterEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onmouseenter, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onmouseenterSetter, CastedThisErrorBehavior::ReturnEarly>(*lexicalGlobalObject, thisValue, encodedValue, "onmouseenter");
}

static inline JSValue jsMathMLElement_onmouseleaveGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().mouseleaveEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onmouseleave, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onmouseleaveGetter, CastedThisErrorBehavior::ReturnEarly>(*lexicalGlobalObject, thisValue, "onmouseleave");
}

static inline bool setJSMathMLElement_onmouseleaveSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().mouseleaveEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onmouseleave, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onmouseleaveSetter, CastedThisErrorBehavior::ReturnEarly>(*lexicalGlobalObject, thisValue, encodedValue, "onmouseleave");
}

static inline JSValue jsMathMLElement_onmousemoveGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().mousemoveEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onmousemove, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onmousemoveGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onmousemove");
}

static inline bool setJSMathMLElement_onmousemoveSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().mousemoveEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onmousemove, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onmousemoveSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onmousemove");
}

static inline JSValue jsMathMLElement_onmouseoutGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().mouseoutEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onmouseout, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onmouseoutGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onmouseout");
}

static inline bool setJSMathMLElement_onmouseoutSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().mouseoutEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onmouseout, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onmouseoutSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onmouseout");
}

static inline JSValue jsMathMLElement_onmouseoverGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().mouseoverEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onmouseover, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onmouseoverGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onmouseover");
}

static inline bool setJSMathMLElement_onmouseoverSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().mouseoverEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onmouseover, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onmouseoverSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onmouseover");
}

static inline JSValue jsMathMLElement_onmouseupGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().mouseupEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onmouseup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onmouseupGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onmouseup");
}

static inline bool setJSMathMLElement_onmouseupSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().mouseupEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onmouseup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onmouseupSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onmouseup");
}

static inline JSValue jsMathMLElement_onpauseGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pauseEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpause, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpauseGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpause");
}

static inline bool setJSMathMLElement_onpauseSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pauseEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpause, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpauseSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpause");
}

static inline JSValue jsMathMLElement_onplayGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().playEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onplay, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onplayGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onplay");
}

static inline bool setJSMathMLElement_onplaySetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().playEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onplay, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onplaySetter>(*lexicalGlobalObject, thisValue, encodedValue, "onplay");
}

static inline JSValue jsMathMLElement_onplayingGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().playingEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onplaying, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onplayingGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onplaying");
}

static inline bool setJSMathMLElement_onplayingSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().playingEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onplaying, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onplayingSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onplaying");
}

static inline JSValue jsMathMLElement_onprogressGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().progressEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onprogress, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onprogressGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onprogress");
}

static inline bool setJSMathMLElement_onprogressSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().progressEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onprogress, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onprogressSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onprogress");
}

static inline JSValue jsMathMLElement_onratechangeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().ratechangeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onratechange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onratechangeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onratechange");
}

static inline bool setJSMathMLElement_onratechangeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().ratechangeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onratechange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onratechangeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onratechange");
}

static inline JSValue jsMathMLElement_onresetGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().resetEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onreset, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onresetGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onreset");
}

static inline bool setJSMathMLElement_onresetSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().resetEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onreset, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onresetSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onreset");
}

static inline JSValue jsMathMLElement_onresizeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().resizeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onresize, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onresizeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onresize");
}

static inline bool setJSMathMLElement_onresizeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().resizeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onresize, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onresizeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onresize");
}

static inline JSValue jsMathMLElement_onscrollGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().scrollEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onscroll, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onscrollGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onscroll");
}

static inline bool setJSMathMLElement_onscrollSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().scrollEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onscroll, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onscrollSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onscroll");
}

static inline JSValue jsMathMLElement_onseekedGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().seekedEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onseeked, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onseekedGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onseeked");
}

static inline bool setJSMathMLElement_onseekedSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().seekedEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onseeked, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onseekedSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onseeked");
}

static inline JSValue jsMathMLElement_onseekingGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().seekingEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onseeking, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onseekingGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onseeking");
}

static inline bool setJSMathMLElement_onseekingSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().seekingEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onseeking, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onseekingSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onseeking");
}

static inline JSValue jsMathMLElement_onselectGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().selectEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onselect, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onselectGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onselect");
}

static inline bool setJSMathMLElement_onselectSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().selectEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onselect, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onselectSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onselect");
}

static inline JSValue jsMathMLElement_onslotchangeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().slotchangeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onslotchange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onslotchangeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onslotchange");
}

static inline bool setJSMathMLElement_onslotchangeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().slotchangeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onslotchange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onslotchangeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onslotchange");
}

static inline JSValue jsMathMLElement_onstalledGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().stalledEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onstalled, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onstalledGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onstalled");
}

static inline bool setJSMathMLElement_onstalledSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().stalledEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onstalled, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onstalledSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onstalled");
}

static inline JSValue jsMathMLElement_onsubmitGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().submitEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onsubmit, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onsubmitGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onsubmit");
}

static inline bool setJSMathMLElement_onsubmitSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().submitEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onsubmit, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onsubmitSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onsubmit");
}

static inline JSValue jsMathMLElement_onsuspendGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().suspendEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onsuspend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onsuspendGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onsuspend");
}

static inline bool setJSMathMLElement_onsuspendSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().suspendEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onsuspend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onsuspendSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onsuspend");
}

static inline JSValue jsMathMLElement_ontimeupdateGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().timeupdateEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontimeupdate, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontimeupdateGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontimeupdate");
}

static inline bool setJSMathMLElement_ontimeupdateSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().timeupdateEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontimeupdate, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontimeupdateSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontimeupdate");
}

static inline JSValue jsMathMLElement_ontoggleGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().toggleEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontoggle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontoggleGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontoggle");
}

static inline bool setJSMathMLElement_ontoggleSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().toggleEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontoggle, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontoggleSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontoggle");
}

static inline JSValue jsMathMLElement_onvolumechangeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().volumechangeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onvolumechange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onvolumechangeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onvolumechange");
}

static inline bool setJSMathMLElement_onvolumechangeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().volumechangeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onvolumechange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onvolumechangeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onvolumechange");
}

static inline JSValue jsMathMLElement_onwaitingGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().waitingEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwaiting, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwaitingGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwaiting");
}

static inline bool setJSMathMLElement_onwaitingSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().waitingEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwaiting, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwaitingSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwaiting");
}

static inline JSValue jsMathMLElement_onwebkitanimationendGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().webkitAnimationEndEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwebkitanimationend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwebkitanimationendGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwebkitanimationend");
}

static inline bool setJSMathMLElement_onwebkitanimationendSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().webkitAnimationEndEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwebkitanimationend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwebkitanimationendSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwebkitanimationend");
}

static inline JSValue jsMathMLElement_onwebkitanimationiterationGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().webkitAnimationIterationEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwebkitanimationiteration, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwebkitanimationiterationGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwebkitanimationiteration");
}

static inline bool setJSMathMLElement_onwebkitanimationiterationSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().webkitAnimationIterationEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwebkitanimationiteration, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwebkitanimationiterationSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwebkitanimationiteration");
}

static inline JSValue jsMathMLElement_onwebkitanimationstartGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().webkitAnimationStartEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwebkitanimationstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwebkitanimationstartGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwebkitanimationstart");
}

static inline bool setJSMathMLElement_onwebkitanimationstartSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().webkitAnimationStartEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwebkitanimationstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwebkitanimationstartSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwebkitanimationstart");
}

static inline JSValue jsMathMLElement_onwebkittransitionendGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().webkitTransitionEndEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwebkittransitionend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwebkittransitionendGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwebkittransitionend");
}

static inline bool setJSMathMLElement_onwebkittransitionendSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().webkitTransitionEndEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwebkittransitionend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwebkittransitionendSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwebkittransitionend");
}

static inline JSValue jsMathMLElement_onwheelGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().wheelEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwheel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwheelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwheel");
}

static inline bool setJSMathMLElement_onwheelSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().wheelEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwheel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwheelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwheel");
}

static inline JSValue jsMathMLElement_onmousewheelGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().mousewheelEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onmousewheel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onmousewheelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onmousewheel");
}

static inline bool setJSMathMLElement_onmousewheelSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().mousewheelEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onmousewheel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onmousewheelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onmousewheel");
}

static inline JSValue jsMathMLElement_onsearchGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().searchEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onsearch, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onsearchGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onsearch");
}

static inline bool setJSMathMLElement_onsearchSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().searchEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onsearch, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onsearchSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onsearch");
}

#if ENABLE(TOUCH_EVENTS)
static inline JSValue jsMathMLElement_ontouchcancelGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().touchcancelEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontouchcancel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontouchcancelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontouchcancel");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline bool setJSMathMLElement_ontouchcancelSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().touchcancelEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontouchcancel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontouchcancelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontouchcancel");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline JSValue jsMathMLElement_ontouchendGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().touchendEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontouchend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontouchendGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontouchend");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline bool setJSMathMLElement_ontouchendSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().touchendEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontouchend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontouchendSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontouchend");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline JSValue jsMathMLElement_ontouchmoveGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().touchmoveEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontouchmove, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontouchmoveGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontouchmove");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline bool setJSMathMLElement_ontouchmoveSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().touchmoveEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontouchmove, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontouchmoveSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontouchmove");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline JSValue jsMathMLElement_ontouchstartGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().touchstartEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontouchstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontouchstartGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontouchstart");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline bool setJSMathMLElement_ontouchstartSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().touchstartEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontouchstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontouchstartSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontouchstart");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline JSValue jsMathMLElement_ontouchforcechangeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().touchforcechangeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontouchforcechange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontouchforcechangeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontouchforcechange");
}

#endif

#if ENABLE(TOUCH_EVENTS)
static inline bool setJSMathMLElement_ontouchforcechangeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().touchforcechangeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontouchforcechange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontouchforcechangeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontouchforcechange");
}

#endif

#if ENABLE(MOUSE_FORCE_EVENTS)
static inline JSValue jsMathMLElement_onwebkitmouseforcechangedGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().webkitmouseforcechangedEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwebkitmouseforcechanged, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwebkitmouseforcechangedGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwebkitmouseforcechanged");
}

#endif

#if ENABLE(MOUSE_FORCE_EVENTS)
static inline bool setJSMathMLElement_onwebkitmouseforcechangedSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().webkitmouseforcechangedEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwebkitmouseforcechanged, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwebkitmouseforcechangedSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwebkitmouseforcechanged");
}

#endif

#if ENABLE(MOUSE_FORCE_EVENTS)
static inline JSValue jsMathMLElement_onwebkitmouseforcedownGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().webkitmouseforcedownEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwebkitmouseforcedown, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwebkitmouseforcedownGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwebkitmouseforcedown");
}

#endif

#if ENABLE(MOUSE_FORCE_EVENTS)
static inline bool setJSMathMLElement_onwebkitmouseforcedownSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().webkitmouseforcedownEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwebkitmouseforcedown, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwebkitmouseforcedownSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwebkitmouseforcedown");
}

#endif

#if ENABLE(MOUSE_FORCE_EVENTS)
static inline JSValue jsMathMLElement_onwebkitmouseforcewillbeginGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().webkitmouseforcewillbeginEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwebkitmouseforcewillbegin, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwebkitmouseforcewillbeginGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwebkitmouseforcewillbegin");
}

#endif

#if ENABLE(MOUSE_FORCE_EVENTS)
static inline bool setJSMathMLElement_onwebkitmouseforcewillbeginSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().webkitmouseforcewillbeginEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwebkitmouseforcewillbegin, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwebkitmouseforcewillbeginSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwebkitmouseforcewillbegin");
}

#endif

#if ENABLE(MOUSE_FORCE_EVENTS)
static inline JSValue jsMathMLElement_onwebkitmouseforceupGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().webkitmouseforceupEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onwebkitmouseforceup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onwebkitmouseforceupGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onwebkitmouseforceup");
}

#endif

#if ENABLE(MOUSE_FORCE_EVENTS)
static inline bool setJSMathMLElement_onwebkitmouseforceupSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().webkitmouseforceupEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onwebkitmouseforceup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onwebkitmouseforceupSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onwebkitmouseforceup");
}

#endif

static inline JSValue jsMathMLElement_onanimationstartGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().animationstartEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onanimationstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onanimationstartGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onanimationstart");
}

static inline bool setJSMathMLElement_onanimationstartSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().animationstartEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onanimationstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onanimationstartSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onanimationstart");
}

static inline JSValue jsMathMLElement_onanimationiterationGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().animationiterationEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onanimationiteration, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onanimationiterationGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onanimationiteration");
}

static inline bool setJSMathMLElement_onanimationiterationSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().animationiterationEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onanimationiteration, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onanimationiterationSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onanimationiteration");
}

static inline JSValue jsMathMLElement_onanimationendGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().animationendEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onanimationend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onanimationendGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onanimationend");
}

static inline bool setJSMathMLElement_onanimationendSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().animationendEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onanimationend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onanimationendSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onanimationend");
}

static inline JSValue jsMathMLElement_onanimationcancelGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().animationcancelEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onanimationcancel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onanimationcancelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onanimationcancel");
}

static inline bool setJSMathMLElement_onanimationcancelSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().animationcancelEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onanimationcancel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onanimationcancelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onanimationcancel");
}

static inline JSValue jsMathMLElement_ontransitionrunGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().transitionrunEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontransitionrun, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontransitionrunGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontransitionrun");
}

static inline bool setJSMathMLElement_ontransitionrunSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().transitionrunEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontransitionrun, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontransitionrunSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontransitionrun");
}

static inline JSValue jsMathMLElement_ontransitionstartGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().transitionstartEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontransitionstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontransitionstartGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontransitionstart");
}

static inline bool setJSMathMLElement_ontransitionstartSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().transitionstartEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontransitionstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontransitionstartSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontransitionstart");
}

static inline JSValue jsMathMLElement_ontransitionendGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().transitionendEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontransitionend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontransitionendGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontransitionend");
}

static inline bool setJSMathMLElement_ontransitionendSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().transitionendEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontransitionend, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontransitionendSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontransitionend");
}

static inline JSValue jsMathMLElement_ontransitioncancelGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().transitioncancelEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ontransitioncancel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ontransitioncancelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ontransitioncancel");
}

static inline bool setJSMathMLElement_ontransitioncancelSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().transitioncancelEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ontransitioncancel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ontransitioncancelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ontransitioncancel");
}

static inline JSValue jsMathMLElement_ongotpointercaptureGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().gotpointercaptureEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_ongotpointercapture, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_ongotpointercaptureGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "ongotpointercapture");
}

static inline bool setJSMathMLElement_ongotpointercaptureSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().gotpointercaptureEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_ongotpointercapture, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_ongotpointercaptureSetter>(*lexicalGlobalObject, thisValue, encodedValue, "ongotpointercapture");
}

static inline JSValue jsMathMLElement_onlostpointercaptureGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().lostpointercaptureEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onlostpointercapture, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onlostpointercaptureGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onlostpointercapture");
}

static inline bool setJSMathMLElement_onlostpointercaptureSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().lostpointercaptureEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onlostpointercapture, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onlostpointercaptureSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onlostpointercapture");
}

static inline JSValue jsMathMLElement_onpointerdownGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pointerdownEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpointerdown, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpointerdownGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpointerdown");
}

static inline bool setJSMathMLElement_onpointerdownSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pointerdownEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpointerdown, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpointerdownSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpointerdown");
}

static inline JSValue jsMathMLElement_onpointermoveGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pointermoveEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpointermove, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpointermoveGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpointermove");
}

static inline bool setJSMathMLElement_onpointermoveSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pointermoveEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpointermove, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpointermoveSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpointermove");
}

static inline JSValue jsMathMLElement_onpointerupGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pointerupEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpointerup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpointerupGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpointerup");
}

static inline bool setJSMathMLElement_onpointerupSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pointerupEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpointerup, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpointerupSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpointerup");
}

static inline JSValue jsMathMLElement_onpointercancelGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pointercancelEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpointercancel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpointercancelGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpointercancel");
}

static inline bool setJSMathMLElement_onpointercancelSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pointercancelEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpointercancel, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpointercancelSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpointercancel");
}

static inline JSValue jsMathMLElement_onpointeroverGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pointeroverEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpointerover, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpointeroverGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpointerover");
}

static inline bool setJSMathMLElement_onpointeroverSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pointeroverEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpointerover, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpointeroverSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpointerover");
}

static inline JSValue jsMathMLElement_onpointeroutGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pointeroutEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpointerout, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpointeroutGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpointerout");
}

static inline bool setJSMathMLElement_onpointeroutSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pointeroutEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpointerout, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpointeroutSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpointerout");
}

static inline JSValue jsMathMLElement_onpointerenterGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pointerenterEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpointerenter, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpointerenterGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpointerenter");
}

static inline bool setJSMathMLElement_onpointerenterSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pointerenterEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpointerenter, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpointerenterSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpointerenter");
}

static inline JSValue jsMathMLElement_onpointerleaveGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().pointerleaveEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onpointerleave, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onpointerleaveGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onpointerleave");
}

static inline bool setJSMathMLElement_onpointerleaveSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().pointerleaveEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onpointerleave, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onpointerleaveSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onpointerleave");
}

static inline JSValue jsMathMLElement_onselectstartGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().selectstartEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onselectstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onselectstartGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onselectstart");
}

static inline bool setJSMathMLElement_onselectstartSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().selectstartEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onselectstart, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onselectstartSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onselectstart");
}

static inline JSValue jsMathMLElement_onselectionchangeGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    UNUSED_PARAM(lexicalGlobalObject);
    return eventHandlerAttribute(thisObject.wrapped(), eventNames().selectionchangeEvent, worldForDOMObject(thisObject));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_onselectionchange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_onselectionchangeGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "onselectionchange");
}

static inline bool setJSMathMLElement_onselectionchangeSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    setEventHandlerAttribute(lexicalGlobalObject, thisObject, thisObject.wrapped(), eventNames().selectionchangeEvent, value);
    vm.heap.writeBarrier(&thisObject, value);
    ensureStillAliveHere(value);

    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_onselectionchange, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_onselectionchangeSetter>(*lexicalGlobalObject, thisValue, encodedValue, "onselectionchange");
}

static inline JSValue jsMathMLElement_datasetGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLInterface<DOMStringMap>>(lexicalGlobalObject, *thisObject.globalObject(), throwScope, impl.dataset())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_dataset, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_datasetGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "dataset");
}

static inline JSValue jsMathMLElement_tabIndexGetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLLong>(lexicalGlobalObject, throwScope, impl.tabIndexForBindings())));
}

JSC_DEFINE_CUSTOM_GETTER(jsMathMLElement_tabIndex, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSMathMLElement>::get<jsMathMLElement_tabIndexGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "tabIndex");
}

static inline bool setJSMathMLElement_tabIndexSetter(JSGlobalObject& lexicalGlobalObject, JSMathMLElement& thisObject, JSValue value)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    CustomElementReactionStack customElementReactionStack(lexicalGlobalObject);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLLong>(lexicalGlobalObject, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(lexicalGlobalObject, throwScope, [&] {
        return impl.setTabIndexForBindings(WTFMove(nativeValue));
    });
    return true;
}

JSC_DEFINE_CUSTOM_SETTER(setJSMathMLElement_tabIndex, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, EncodedJSValue encodedValue))
{
    return IDLAttribute<JSMathMLElement>::set<setJSMathMLElement_tabIndexSetter>(*lexicalGlobalObject, thisValue, encodedValue, "tabIndex");
}

static inline JSC::EncodedJSValue jsMathMLElementPrototypeFunction_focusBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMathMLElement>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    throwScope.release();
    impl.focus();
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsMathMLElementPrototypeFunction_focus, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMathMLElement>::call<jsMathMLElementPrototypeFunction_focusBody>(*lexicalGlobalObject, *callFrame, "focus");
}

static inline JSC::EncodedJSValue jsMathMLElementPrototypeFunction_blurBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperation<JSMathMLElement>::ClassParameter castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto& impl = castedThis->wrapped();
    throwScope.release();
    impl.blur();
    return JSValue::encode(jsUndefined());
}

JSC_DEFINE_HOST_FUNCTION(jsMathMLElementPrototypeFunction_blur, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSMathMLElement>::call<jsMathMLElementPrototypeFunction_blurBody>(*lexicalGlobalObject, *callFrame, "blur");
}

JSC::IsoSubspace* JSMathMLElement::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForMathMLElement.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSMathMLElement> || !JSMathMLElement::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSMathMLElement>)
        spaces.m_subspaceForMathMLElement = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.destructibleObjectHeapCellType.get(), JSMathMLElement);
    else
        spaces.m_subspaceForMathMLElement = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.cellHeapCellType.get(), JSMathMLElement);
    auto* space = spaces.m_subspaceForMathMLElement.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    void (*myVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSMathMLElement::visitOutputConstraints;
    void (*jsCellVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSC::JSCell::visitOutputConstraints;
    if (myVisitOutputConstraint != jsCellVisitOutputConstraint)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

template<typename Visitor>
void JSMathMLElement::visitChildrenImpl(JSCell* cell, Visitor& visitor)
{
    auto* thisObject = jsCast<JSMathMLElement*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitChildren(thisObject, visitor);
#if ENABLE(CSS_TYPED_OM)
    visitor.append(thisObject->m_attributeStyleMap);
#endif
}

DEFINE_VISIT_CHILDREN(JSMathMLElement);

void JSMathMLElement::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSMathMLElement*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

MathMLElement* JSMathMLElement::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSMathMLElement*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(MATHML)
